﻿////-----------------------------------------------
////jqDesigner 设计器
////Date：2021-03-04
////-----------------------------------------------
(function (window, $) {
    var PLUGIN_NAME = "jqDesigner";
    var uid = 0;
    //********************************************************
    //私有方法
    //********************************************************
    function _init(target, state, options) {
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        var selector = state.selector;
        selector.addClass("jquery-designer");
        //设计区域
        state.paintPanel = $(`<div class='paintpanel'>`); //画板区域
        state.config = $("<div class='config'></div>"); // 操作区域 
        state.toolbar = $("<div class='toolbar'></div>"); // 文字编辑区域
        state.dragContainer = $("<div class='dragContainer'></div>"); // 模板内容区域
        selector.append(state.paintPanel);
        state.timer = setInterval(() => {
            if (!state.paintPanel.tempWidth) {
                state.paintPanel.tempWidth = state.paintPanel.width();
            }
            else {
                if (state.paintPanel.tempWidth != state.paintPanel.width()) {
                    state.paintPanel.trigger('resize');
                    state.paintPanel.tempWidth = state.paintPanel.width();
                }
            }
        }, 500);
        state.bgImage = $("<img src='" + state.options.bgImage + "'/>");
       
        state.paintPanel.append(state.bgImage) // 背景图
        selector.append(state.config); //右侧编辑区
        state.config.append(state.toolbar);
        state.config.append(state.dragContainer);
        state.paintPanel.on('mousedown', '.itembox', function (e) {
            e.stopPropagation();
            fn_move(target, this, e);
        })
        state.paintPanel.on('mousedown', '.itembox .zoom', function (e) {
            e.stopPropagation();
            boostMove(target, this, e)
        });
        // 删除
        state.paintPanel.on('click', '.itembox .delete', function (e) {
            e.stopPropagation();
            removeItem(target, this, e);
        });
        // 选中编辑
        $(document).on('click', '.itembox', function (e) {
            chooseItem(target, this, e);
        });
        // 加粗
        $(document).on('click', '.weight', function (e) {
            fontWeight(target, this, e)
        });
        // 斜体
        $(document).on('click', '.italics', function (e) {
            Italics(target, this, e)
        });
        // 下划线
        $(document).on('click', '.underLine', function (e) {
            underLine(target, this, e)
        });
        //布局
        $(document).on('click', '.align', function (e) {
            halign(target, this, e)
        });
        state.dragContainer.on('dragstart', '.dragItem', function (e) { // 拖拽事件绑定到元素上
            var dragItem = JSON.parse($(this).attr("data-item")); // 获取到元素绑定的属性值
            state.dragItemData = dragItem;
            //$(document).on('dragenter', '.paintpanel', function () { })
            //$(document).on('dragover', '.paintpanel', function (event) { // 这行代码一定要有，阻止事件的默认行为，才能触发鼠标放下的事件
            //    event.preventDefault()
            //})
        })
        state.dragContainer.on('dragover', '.dragItem',  function (event) {
            event.preventDefault();
        });
        state.paintPanel.on('dragenter',function (event) {
            event.preventDefault();
        });
        state.paintPanel.on('dragover', function (event) {
            event.preventDefault();
        });
        state.paintPanel.on('drop','img', function (e) { // // 鼠标放下事件被触发把元素添加到bbox中
            // console.log(document.documentElement.scrollTop)
            console.log(e.target);
            // 防止事件默认行为（比如某些元素节点上可以打开链接），
            e.preventDefault();
            //var X = (e.originalEvent.clientX - state.paintPanel.offset().left + $(document).scrollLeft());
            //var Y = (e.originalEvent.clientY - state.paintPanel.offset().top + $(document).scrollTop());
            var posX = e.offsetX, posY = e.offsetY;

            state.dragItemData.X = posX / state.sizeP;// * (state.paintPanel.width() / $(document).width());
            state.dragItemData.Y = posY / state.sizeP;// * (state.paintPanel.height() / $(document).height());
            state.dragItemData.HAlign = "left";
            state.dragItemData.VAlign = "left";
            state.dragItemData.FontStyle = {
                FontName: "微软雅黑",
                FontSize: 16,
                FontColor: "#333",
                IsBold: false,
                IsItalic: false,
                IsUnderLine: false,
            };
            add(target, state.dragItemData, true)
        })
        //$(document).on('drop', '.paintpanel', function (e) { // 定时器解绑事件，不然会一直绑定事件，重复添加数据
        //    debugger
        //    // 防止事件默认行为（比如某些元素节点上可以打开链接），
        //    event.preventDefault();
        //    //var timer = setInterval(function () {
        //    //    state.paintPanel.off('dragover')
        //    //    state.paintPanel.off('dragenter')
        //    //    state.paintPanel.off('drop')
        //    //    clearInterval(timer);
        //    //}, 30)
        //})
        state.paintPanel.on('resize', function () {
            var p = state.bgImage.width() / state.bgImage.orgWidth;
            state.sizeP = p;
            renderItem(target)
        });
        rendToolbar(target);
        renddragItem(target);
        renderItem(target);
        if (state.bgImage.attr('src') != '') {
            state.bgImage.on('load',function (e) {
                state.bgImage.orgWidth = e.target.naturalWidth;
                state.paintPanel.trigger('resize');
            });
        }
    }
    function rendToolbar(target) {
        var _toolbars = [{
            name: '字体颜色',
            icon: '',
            cmd: '<input id="colorInput" value="rgb(255,0,0)" type="color">'
        },
        {
            name: '背景颜色',
            icon: '',
            cmd: '<input id="bgcolorInput" value="rgb(255,0,0)" type="color"> | <button id="clearBgColor">无背景色</button>'
        },
        {
            name: '字号',
            icon: '',
            cmd: `
                    <select name="" id="fontSize" @@change="changeFontSize" v-model="fontSize">
                        <option value="12">12</option>
                        <option value="14">14</option>
                        <option value="16">16</option>
                        <option value="18">18</option>
                        <option value="20">20</option>
                        <option value="22">22</option>
                        <option value="24">24</option>
                        <option value="26">26</option>
                        <option value="28">28</option>
                        <option value="30">30</option>
                        <option value="32">32</option>
                        <option value="34">34</option>
                        <option value="36">36</option>
                        <option value="38">38</option>
                        <option value="40">40</option>
                        <option value="42">42</option>
                    </select>`
        }, {
            name: '加粗',
            icon: '',
            cmd: `<span class="weight"></span>`
        }, {
            name: '斜体',
            icon: '',
            cmd: `<span class="italics"></span>`
        }, {
            name: '下划线',
            icon: '',
            cmd: `<span class="underLine"></span>`
            },
            {
                name: '布局',
                icon: '',
                cmd: `<span class="align align-left" data-align="left"></span><span class="align align-center" data-align="center"></span><span class="align align-right" data-align="right"></span>`
            }];
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        for (var i = 0; i < options.toolbars.length; i++) {
            for (var j = 0; j < _toolbars.length; j++) {
                if (_toolbars[j].name == options.toolbars[i]) {
                    state.toolbar.append(`
                    <div class='toolbar-box'>
                        <div class='left'>` + _toolbars[i].name + `:</div>
                        <div class='right'>` + _toolbars[i].cmd + `</div>
                    </div>`);
                }
            }
        }
        var state = $.data(target, PLUGIN_NAME);
        $('#colorInput').on('change', function () {
            var color = $(this).val();
            state.selectItem.css({
                'color': color
            })
        });
        $('#bgcolorInput').on('change', function () {
            var color = $(this).val();
            state.selectItem.css({
                'background-color': color
            })
        });
        $('#clearBgColor').on('click', function () {
            state.selectItem.css({
                'background-color':''
            })
        });
        $('#fontSize').on('change', function () {
            var value = $(this).val();
            state.selectItem.css({
                'fontSize': value + 'px'
            })
        });
    }

    function renderItem(target) {
        var state = $.data(target, PLUGIN_NAME);
        var aItem = state.options.configItem;
        if (!state.sizeP) state.sizeP = 1;
        if (aItem.lenfth == 0) { return }
        state.paintPanel.find('.itembox').remove();
        for (let i = 0; i < aItem.length; i++) {
            add(target, aItem[i], false);
            //var FontWeight = aItem[i].FontStyle.IsBold ? 'bold' : 'normal'
            //var IsItalic = aItem[i].FontStyle.IsItalic ? 'italic' : 'normal'
            //var underLine = aItem[i].FontStyle.IsUnderLine ? 'underline' : 'none'
            //if (aItem[i].Type == 1) {
            //    state.paintPanel.append($(`<div class='itembox' data-Type=` + aItem[i].Type + ` data-Name=` + aItem[i].Name + ` data-DefaultValue=` + aItem[i].DefaultValue + ` data-DataField=` + aItem[i].DataField + ` style="z-index:9999;left:` + aItem[i].X * state.sizeP + `px;top:` + aItem[i].Y * state.sizeP + `px;font-size:` + aItem[i].FontStyle.FontSize * state.sizeP + `px;color:` + aItem[i].FontStyle.FontColor + `;font-weight:` + FontWeight + `;text-decoration:` + underLine + `;font-style:` + IsItalic + `;"><div class='content-jq' style="padding-right:10px;">` + aItem[i].DefaultValue + `<span class='delete'></span></div></div>`))
            //} else {
            //    state.paintPanel.append($(`<div class='itembox imagebox' data-Type=` + aItem[i].Type + ` data-Name=` + aItem[i].Name + ` data-DefaultValue=` + aItem[i].DefaultValue + ` data-DataField=` + aItem[i].DataField + ` style="z-index:9999;left:` + aItem[i].X * state.sizeP + `px;top:` + aItem[i].Y * state.sizeP + `px;background:url('` + aItem[i].DefaultValue + `') no-repeat;background-size:100% 100%;width:` + aItem[i].Width * state.sizeP + `px;height:` + aItem[i].Height * state.sizeP + `px" ><div class='content-jq'><span class='zoom'></span><span class='delete'></span></div></div>`))
            //}
        }
    }

    function renddragItem(target) {
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        for (var i = 0; i < options.dragItems.length; i++) {
            if (options.dragItems[i].Type == 1) {
                state.dragContainer.append(`
                    <div class='dragItem' draggable="true" data-item='` + JSON.stringify(options.dragItems[i]) + `'>
                        <div class='left'>` + options.dragItems[i].Name + `:</div>
                        <div class='right'>` + options.dragItems[i].DefaultValue + `</div>
                    </div>
                `)
            } else {
                state.dragContainer.append(`
                <div class='dragItem-img dragItem' data-item='` + JSON.stringify(options.dragItems[i]) + `'>
                    <img src='` + options.dragItems[i].DefaultValue + `' />
                </div>
            `)
            }
        }
    }

    function Italics(target, item) {
        var state = $.data(target, PLUGIN_NAME);
        if (!state.selectItem) return;

        if (state.selectItem.css('fontStyle') == 'italic') {
            $(item).css({
                border: "none"
            })
            state.selectItem.css({
                'fontStyle': 'normal'
            })
        } else {
            $(item).css({
                border: "2px solid #f33"
            })
            state.selectItem.css({
                'fontStyle': ' italic'
            })
        }
    }

    function fontWeight(target, item) {
        var state = $.data(target, PLUGIN_NAME);
        if (!state.selectItem) return;
        if (state.selectItem.css('fontWeight') == '700') {
            $(item).css({
                border:"none"
            })
            state.selectItem.css({
                'fontWeight': 'normal'
            })
        } else {
            $(item).css({
                border:"2px solid #f33"
            })
            state.selectItem.css({
                'fontWeight': 'bold'
            })
        }
    }

    function underLine(target, item) {
        var state = $.data(target, PLUGIN_NAME);
        if (!state.selectItem) return;
        // console.log($(items).css('textDecoration').indexOf('underline'))
        if (state.selectItem.css('textDecoration').indexOf('underline') != -1) {
            $(item).css({
                border: "none"
            })
            state.selectItem.css({
                'text-decoration': 'none'
            })
        } else {
            $(item).css({
                border: "2px solid #f33"
            })
            state.selectItem.css({
                'text-decoration': 'underline'
            })
        }
    }

    function halign(target, item) {
        var state = $.data(target, PLUGIN_NAME);
        var align = $(item).attr('data-align');
        if (!state.selectItem) return;
        state.toolbar.find('.align').css('border', 'none');
       
        $(item).css({
            border: "2px solid #f33"
        })
        state.selectItem.css({
            'justify-content': _hAlignToCss(align)
        })
    }
    //  元素拖拽移动
    function fn_move(target, item, e) {
        var state = $.data(target, PLUGIN_NAME);
        // console.log(state)
        let oDiv = $(item)
        // console.log(oDiv)
        let disX = e.clientX - oDiv.offset().left;
        let disY = e.clientY - oDiv.offset().top;
        // console.log(disX + ',' + disY)
        state.options.item = $(item)
        var oBoxDiv = $('.paintpanel')
        // console.log(oBoxDiv.offset().top)
        $(document).mousemove(function (e) {
            let left = e.clientX - disX - oBoxDiv.offset().left;
            let top = e.clientY - disY - oBoxDiv.offset().top;
            let maxY = oBoxDiv[0].clientHeight - oDiv[0].clientHeight
            let maxX = oBoxDiv[0].clientWidth - oDiv[0].clientWidth
            // console.log(e.clientX + ',' + e.clientY)
            if (left <= 0) {
                left = 0
            }
            if (left >= maxX) {
                left = maxX
            }
            if (top <= 0) {
                top = 0
            }
            if (top >= maxY) {
                top = maxY
            }
            // this.X = left
            // this.Y = top
            oDiv.css({
                'left': left + 'px',
                'top': top + 'px'
            });
        });
        $(document).mouseup(function () {
            $(document).off('mousemove');
        });
    }

    function removeItem(target, item, e) {
        $(item).parent().remove();
    }

    // 改变元素宽高
    function boostMove(target, item, e) {
        e.stopPropagation();
        e.cancelBubble = true;
        var box2 = $(item).parent();
        var state = $.data(target, PLUGIN_NAME);
        var oBoxDiv = state.paintPanel
        var oBoost = $(item)
        var width = box2.width();
        var height = box2.height();
        var nowX = e.clientX;
        var nowY = e.clientY;
        document.onmousemove = function (e) {
            var a = width + e.clientX - nowX;
            var b = height + e.clientY - nowY;
            if (a > oBoxDiv.width()) {
                a = oBoxDiv.width();
            }
            if (b > oBoxDiv.height()) {
                b = oBoxDiv.height();
            }
            box2.css({
                'width': a + "px",
                'height': b + "px"
            })
            box2.data('config', { Width: a, Height: b });
        }
        document.onmouseup = (e) => {
            document.onmousemove = null
            document.onmouseup = null
        }
    }

    function _cssToHAlign(halign) {
        var align = "left";
        if (halign == 'flex-start') {
            align = "left";
        }
        else if (halign == 'center') {
            align = "center";
        }
        else if (halign == 'flex-end') {
            align = "right";
        }
        return align;
    }

    function _hAlignToCss(align) {
        var halign = "flex-start";
        if (align == 'left') {
            halign = "flex-start";
        }
        else if (align == 'center') {
            halign = "center";
        }
        else if (align == 'right') {
            halign = "flex-end";
        }
        return halign;
    }

    // 添加模板信息到画板
    function add(target, item, isActive) {
        var state = $.data(target, PLUGIN_NAME);
        //var dragItem = JSON.parse(item);
       // item = JSON.parse(item);
        var ebox = $(`<div class='itembox' data-DataField=` + item.DataField + ` data-DefaultValue=` + item.DefaultValue + ` data-Type=` + item.Type + ` data-Name=` + item.Name + ` style=""></div>`);
        ebox.append("<span class='zoom'></span>");
        ebox.append("<span class='delete'></span>");
        var eitem = $("<div class='content'></div>");
        ebox.css('z-index', '9999');
        ebox.css('left', item.X * state.sizeP + 'px');
        ebox.css('top', item.Y * state.sizeP + 'px');
        ebox.css('width', item.Width * state.sizeP + 'px');
        ebox.css('height', item.Height * state.sizeP + 'px');
        ebox.css('background-color', item.BackgroundColor);
        
        if (item.Type == 2) {
            ebox.addClass('imagebox');
            ebox.css('background', "url(" + item.DefaultValue+") no-repeat");
            ebox.css('background-size', "100% 100%");
            eitem.text(item.Name);
        } else {
            ebox.css('font-size', item.FontStyle.FontSize * state.sizeP + 'px');
            ebox.css('color', item.FontStyle.FontColor);
            ebox.css('font-weight', item.FontStyle.IsBold ? 'bold' : 'normal');
            ebox.css('text-decoration', item.FontStyle.IsUnderLine ? 'underline' : 'none');
            ebox.css('font-style', item.FontStyle.IsItalic ? 'italic' : 'normal');
            ebox.css('justify-content', _hAlignToCss(item.HAlign));
            eitem.text(item.DefaultValue);
            //var DefaultValue = JSON.stringify(item.DefaultValue)
            //console.log(item.DefaultValue)
            //state.paintPanel.append($(`<div class='itembox active' data-DataField=` + item.DataField + ` data-DefaultValue=` + DefaultValue + ` data-Type=` + item.Type + ` data-Name=` + item.Name + ` style="z-index:9999;left:` + X + `;top:` + Y + `"><div class='content-jq' style="padding-right:10px">` + item.DefaultValue + `<span class='delete'></span></div></div>`))
        }
        ebox.append(eitem);
        if (isActive) {
            ebox.addClass("active");
        }
        state.paintPanel.append(ebox);
    }

    function chooseItem(target, item, e) {
        var state = $.data(target, PLUGIN_NAME);
        state.paintPanel.find('.itembox').removeClass('active');
        state.selectItem = $(item);
        $(item).addClass('active');
        //$('.move').css({
        //    backgroundColor: ''
        //})
        //$(item).css({
        //    backgroundColor: 'rgba(255, 0, 0, .1)'
        //});
        // 颜色一致
        var color = state.selectItem.css('color')
        $('#colorInput').val(rgb(color))
        var bgcolor = state.selectItem.css('background-color');
        if (bgcolor != '') {
            $('#bgcolorInput').val(rgb(bgcolor))
        }
        // 字体大小一致
        var FontSize = state.selectItem.css('fontSize').substring(0, 2);
        var fontSizeIdx = -1;
        $('#fontSize').find('option').each(function (i, item) {
            var opt = $(item);
            if (opt.val() == FontSize) {
                $(`#fontSize option[value=` + FontSize + `]`).attr("selected", true);
                fontSizeIdx = i;
            }
        });
        if (fontSizeIdx == -1) {
            $("#fontSize").append("<option value=" + FontSize + " selected>" + FontSize + "</option>");
        }
        // 下划线
        var underLine = state.selectItem.css('text-decoration').indexOf('underline')
        if (underLine != -1) {
            $('.underLine').css({
                border: '2px solid #f33'
            })
        }
        // 加粗
        var FontWeight = state.selectItem.css('fontWeight')
        if (FontWeight == 700) {
            $('.weight').css({
                border: '2px solid #f33'
            })
        }
        // 斜体
        var italics = state.selectItem.css('fontStyle')
        if (italics == 'italic') {
            $('.italics').css({
                border: '2px solid #f33'
            })
        }
        //布局
        var halign = state.selectItem.css('justify-content');
        state.toolbar.find('.align-' + _cssToHAlign(halign)).css({
            border: '2px solid #f33'
        })
    }

    function rgb(rgb) {
        if (rgb.charAt(0) == '#')
            return rgb;
        var ds = rgb.split(/\D+/);
        var decimal = Number(ds[1]) * 65536 + Number(ds[2]) * 256 + Number(ds[3]);
        return "#" + zero_fill_hex(decimal, 6);
    }

    function zero_fill_hex(num, digits) {
        var s = num.toString(16);
        while (s.length < digits)
            s = "0" + s;
        return s;
    }

    function _getConfig(target) {
        var state = $.data(target, PLUGIN_NAME);
        var aData = $('.itembox')
        var config = []
        for (let i = 0; i < aData.length; i++) {
            config.push({
                DataField: $(aData[i]).data('datafield'),
                DefaultValue: $(aData[i]).data('defaultvalue'),
                Name: $(aData[i]).data('name'),
                Type: $(aData[i]).data('type'),
                Width: Math.ceil(Number(($(aData[i]).css('width')).replace("px", "")) / state.sizeP),
                Height: Math.ceil(Number(($(aData[i]).css('height')).replace("px", "")) / state.sizeP),
                X: Math.ceil(Number(($(aData[i]).css('left')).replace("px", "")) / state.sizeP),
                Y: Math.ceil(Number(($(aData[i]).css('top')).replace("px", "")) / state.sizeP),
                HAlign: _cssToHAlign($(aData[i]).css('justify-content')),
                VAlign: _cssToHAlign($(aData[i]).css('justify-content')),
                BackgroundColor: $(aData[i]).css('background-color').replace(/\s*/g, ""),
                FontStyle: {
                    FontSize: Math.ceil(Number(($(aData[i]).css('fontSize')).replace("px", "")) / state.sizeP),
                    FontColor: $(aData[i]).css('color').replace(/\s*/g, ""),
                    IsBold: $(aData[i]).css('fontWeight') == 700 ? true : false,
                    IsItalic: $(aData[i]).css('fontStyle') == 'italic' ? true : false,
                    IsUnderLine: $(aData[i]).css('textDecoration').indexOf('underline') != -1 ? true : false,
                    FontName: '微软雅黑',
                }
            })
        }
        console.log(config)
        return config
    }

    function _options(target, options) {
        var state = $.data(target, PLUGIN_NAME);
        state.options = $.extend({}, state.options, options);
        renddragItem(target);
        state.bgImage.attr('src', state.options.bgImage);
        state.bgImage.on('load', function (e) {
            state.bgImage.orgWidth = e.target.naturalWidth;
            state.paintPanel.trigger('resize');
        });
    }
    function _destroy(target) {
        var state = $.data(target, PLUGIN_NAME);
        state.timer && clearInterval(state.timer);
        var options = state.options;
        state.selector.remove();
        $(document).off('.btn-jq');
        console.log(state.selector)
        $.data(target, PLUGIN_NAME, null);
    }

    $.fn[PLUGIN_NAME] = function (options) {
        if (typeof options === 'string' && $.fn[PLUGIN_NAME].methods[options]) {
            return $.fn[PLUGIN_NAME].methods[options].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof options === 'object' || !options) {
            return $.fn[PLUGIN_NAME].methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + options + ' does not exist on jQuery' + PLUGIN_NAME);
        }
    };
    $.fn[PLUGIN_NAME].version = "1.0";
    $.fn[PLUGIN_NAME].defaults = {
        toolbars: ['字体颜色','背景颜色','字号','加粗','斜体','下划线','布局'],
        dragItems: [],
        configItem: [],
        bgImage: {}
    };
    $.fn[PLUGIN_NAME].methods = {
        init: function (options) {
            return this.each(function () {
                var $this = $(this);
                var state = $.data(this, PLUGIN_NAME);
                if (state) {
                    $.extend(state.options, options);
                } else {
                    var settings = $.extend({}, $.fn[PLUGIN_NAME].defaults, options);
                    state = $.data(this, PLUGIN_NAME, {
                        target: this,
                        selector: $this,
                        options: settings,
                        vars: {},
                    });
                    _init(this, state, options);
                }
            });
        },
        destroy: function () {
            return this.each(function () {
                _destroy(this);
            });
        },
        getConfig: function () {
            return _getConfig(this[0])
            // return _getSelections(this[0]);
        },
        options: function (params) {
            return this.each(function () {
                _options(this, params);
            });
        }
    };
})(window, jQuery);